swaroop: refresh buttons for playlists / content.
[dcpomatic.git] / wscript
1 #
2 #    Copyright (C) 2012-2017 Carl Hetherington <cth@carlh.net>
3 #
4 #    This file is part of DCP-o-matic.
5 #
6 #    DCP-o-matic is free software; you can redistribute it and/or modify
7 #    it under the terms of the GNU General Public License as published by
8 #    the Free Software Foundation; either version 2 of the License, or
9 #    (at your option) any later version.
10 #
11 #    DCP-o-matic is distributed in the hope that it will be useful,
12 #    but WITHOUT ANY WARRANTY; without even the implied warranty of
13 #    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
14 #    GNU General Public License for more details.
15 #
16 #    You should have received a copy of the GNU General Public License
17 #    along with DCP-o-matic.  If not, see <http://www.gnu.org/licenses/>.
18 #
19
20 import subprocess
21 import os
22 import shlex
23 import sys
24 import glob
25 import distutils
26 import distutils.spawn
27 try:
28     # python 2
29     from urllib import urlencode
30 except ImportError:
31     # python 3
32     from urllib.parse import urlencode
33 from waflib import Logs, Context
34
35 APPNAME = 'dcpomatic'
36
37 this_version = subprocess.Popen(shlex.split('git tag -l --points-at HEAD'), stdout=subprocess.PIPE).communicate()[0]
38 last_version = subprocess.Popen(shlex.split('git describe --tags --abbrev=0'), stdout=subprocess.PIPE).communicate()[0]
39
40 if this_version == '':
41     VERSION = '%sdevel' % last_version[1:].strip()
42 else:
43     VERSION = this_version[1:].strip()
44
45 def options(opt):
46     opt.load('compiler_cxx')
47     opt.load('winres')
48
49     opt.add_option('--enable-debug',      action='store_true', default=False, help='build with debugging information and without optimisation')
50     opt.add_option('--disable-gui',       action='store_true', default=False, help='disable building of GUI tools')
51     opt.add_option('--disable-tests',     action='store_true', default=False, help='disable building of tests')
52     opt.add_option('--install-prefix',                         default=None,  help='prefix of where DCP-o-matic will be installed')
53     opt.add_option('--target-windows',    action='store_true', default=False, help='set up to do a cross-compile to make a Windows package')
54     opt.add_option('--static-dcpomatic',  action='store_true', default=False, help='link to components of DCP-o-matic statically')
55     opt.add_option('--static-boost',      action='store_true', default=False, help='link statically to Boost')
56     opt.add_option('--static-wxwidgets',  action='store_true', default=False, help='link statically to wxWidgets')
57     opt.add_option('--static-ffmpeg',     action='store_true', default=False, help='link statically to FFmpeg')
58     opt.add_option('--static-xmlpp',      action='store_true', default=False, help='link statically to libxml++')
59     opt.add_option('--static-xmlsec',     action='store_true', default=False, help='link statically to xmlsec')
60     opt.add_option('--static-ssh',        action='store_true', default=False, help='link statically to libssh')
61     opt.add_option('--static-cxml',       action='store_true', default=False, help='link statically to libcxml')
62     opt.add_option('--static-dcp',        action='store_true', default=False, help='link statically to libdcp')
63     opt.add_option('--static-sub',        action='store_true', default=False, help='link statically to libsub')
64     opt.add_option('--static-curl',       action='store_true', default=False, help='link statically to libcurl')
65     opt.add_option('--workaround-gssapi', action='store_true', default=False, help='link to gssapi_krb5')
66     opt.add_option('--force-cpp11',       action='store_true', default=False, help='force use of C++11')
67     opt.add_option('--variant',           help='build variant', choices=['swaroop'])
68
69 def configure(conf):
70     conf.load('compiler_cxx')
71     conf.load('clang_compilation_database', tooldir=['waf-tools'])
72     if conf.options.target_windows:
73         conf.load('winres')
74
75     # Save conf.options that we need elsewhere in conf.env
76     conf.env.DISABLE_GUI = conf.options.disable_gui
77     conf.env.DISABLE_TESTS = conf.options.disable_tests
78     conf.env.TARGET_WINDOWS = conf.options.target_windows
79     conf.env.TARGET_OSX = sys.platform == 'darwin'
80     conf.env.TARGET_LINUX = not conf.env.TARGET_WINDOWS and not conf.env.TARGET_OSX
81     conf.env.VERSION = VERSION
82     conf.env.DEBUG = conf.options.enable_debug
83     conf.env.STATIC_DCPOMATIC = conf.options.static_dcpomatic
84     if conf.options.install_prefix is None:
85         conf.env.INSTALL_PREFIX = conf.env.PREFIX
86     else:
87         conf.env.INSTALL_PREFIX = conf.options.install_prefix
88
89     # Common CXXFLAGS
90     conf.env.append_value('CXXFLAGS', ['-D__STDC_CONSTANT_MACROS',
91                                        '-D__STDC_LIMIT_MACROS',
92                                        '-D__STDC_FORMAT_MACROS',
93                                        '-msse',
94                                        '-fno-strict-aliasing',
95                                        '-Wall',
96                                        '-Wcast-align',
97                                        '-Wextra',
98                                        '-Wwrite-strings',
99                                        # Remove auto_ptr warnings from libxml++-2.6
100                                        '-Wno-deprecated-declarations',
101                                        '-Wno-ignored-qualifiers',
102                                        '-D_FILE_OFFSET_BITS=64'])
103
104     if conf.options.force_cpp11:
105         conf.env.append_value('CXXFLAGS', ['-std=c++11', '-DBOOST_NO_CXX11_SCOPED_ENUMS'])
106
107     gcc = conf.env['CC_VERSION']
108     if int(gcc[0]) >= 4 and int(gcc[1]) > 1:
109         conf.env.append_value('CXXFLAGS', ['-Wno-unused-result'])
110     have_c11 = int(gcc[0]) >= 4 and int(gcc[1]) >= 8 and int(gcc[2]) >= 1
111
112     if conf.options.enable_debug:
113         conf.env.append_value('CXXFLAGS', ['-g', '-DDCPOMATIC_DEBUG', '-fno-omit-frame-pointer'])
114     else:
115         conf.env.append_value('CXXFLAGS', '-O2')
116
117     if conf.options.variant is not None:
118         conf.env.VARIANT = conf.options.variant
119         conf.env.append_value('CXXFLAGS', '-DDCPOMATIC_VARIANT_%s' % conf.options.variant.upper())
120
121     #
122     # Windows/Linux/OS X specific
123     #
124
125     # Windows
126     if conf.env.TARGET_WINDOWS:
127         conf.env.append_value('CXXFLAGS', '-DDCPOMATIC_WINDOWS')
128         conf.env.append_value('CXXFLAGS', '-DWIN32_LEAN_AND_MEAN')
129         conf.env.append_value('CXXFLAGS', '-DBOOST_USE_WINDOWS_H')
130         conf.env.append_value('CXXFLAGS', '-DUNICODE')
131         conf.env.append_value('CXXFLAGS', '-DBOOST_THREAD_PROVIDES_GENERIC_SHARED_MUTEX_ON_WIN')
132         conf.env.append_value('CXXFLAGS', '-mfpmath=sse')
133         conf.env.append_value('CXXFLAGS', '-std=c++11')
134         wxrc = os.popen('wx-config --rescomp').read().split()[1:]
135         conf.env.append_value('WINRCFLAGS', wxrc)
136         if conf.options.enable_debug:
137             conf.env.append_value('CXXFLAGS', ['-mconsole'])
138             conf.env.append_value('LINKFLAGS', ['-mconsole'])
139         conf.check(lib='ws2_32', uselib_store='WINSOCK2', msg="Checking for library winsock2")
140         conf.check(lib='dbghelp', uselib_store='DBGHELP', msg="Checking for library dbghelp")
141         conf.check(lib='shlwapi', uselib_store='SHLWAPI', msg="Checking for library shlwapi")
142         conf.check(lib='mswsock', uselib_store='MSWSOCK', msg="Checking for library mswsock")
143         conf.check(lib='ole32', uselib_store='OLE32', msg="Checking for library ole32")
144         conf.check(lib='dsound', uselib_store='DSOUND', msg="Checking for library dsound")
145         conf.check(lib='winmm', uselib_store='WINMM', msg="Checking for library winmm")
146         conf.check(lib='ksuser', uselib_store='KSUSER', msg="Checking for library ksuser")
147         boost_lib_suffix = '-mt'
148         boost_thread = 'boost_thread_win32-mt'
149         conf.check_cxx(fragment="""
150                                #include <boost/locale.hpp>\n
151                                int main() { std::locale::global (boost::locale::generator().generate ("")); }\n
152                                """,
153                                msg='Checking for boost locale library',
154                                libpath='/usr/local/lib',
155                                lib=['boost_locale%s' % boost_lib_suffix, 'boost_system%s' % boost_lib_suffix],
156                                uselib_store='BOOST_LOCALE')
157
158     # POSIX
159     if conf.env.TARGET_LINUX or conf.env.TARGET_OSX:
160         conf.env.append_value('CXXFLAGS', '-DDCPOMATIC_POSIX')
161         boost_lib_suffix = ''
162         boost_thread = 'boost_thread'
163         conf.env.append_value('LINKFLAGS', '-pthread')
164
165     # Linux
166     if conf.env.TARGET_LINUX:
167         conf.env.append_value('CXXFLAGS', '-mfpmath=sse')
168         conf.env.append_value('CXXFLAGS', '-DLINUX_LOCALE_PREFIX="%s/share/locale"' % conf.env['INSTALL_PREFIX'])
169         conf.env.append_value('CXXFLAGS', '-DLINUX_SHARE_PREFIX="%s/share/dcpomatic2"' % conf.env['INSTALL_PREFIX'])
170         conf.env.append_value('CXXFLAGS', '-DDCPOMATIC_LINUX')
171         conf.env.append_value('CXXFLAGS', ['-Wlogical-op'])
172         if not conf.env.DISABLE_GUI:
173             conf.check_cfg(package='gtk+-2.0', args='--cflags --libs', uselib_store='GTK', mandatory=True)
174
175     # OSX
176     if conf.env.TARGET_OSX:
177         conf.env.append_value('CXXFLAGS', ['-DDCPOMATIC_OSX', '-Wno-unused-function', '-Wno-unused-parameter', '-Wno-unused-local-typedef', '-Wno-potentially-evaluated-expression'])
178         conf.env.append_value('LINKFLAGS', '-headerpad_max_install_names')
179
180     #
181     # Dependencies.
182     #
183
184     # It should be possible to use check_cfg for both dynamic and static linking, but
185     # e.g. pkg-config --libs --static foo returns some libraries that should be statically
186     # linked and others that should be dynamic.  This doesn't work too well with waf
187     # as it wants them separate.
188
189     # libcurl
190     if conf.options.static_curl:
191         conf.env.STLIB_CURL = ['curl']
192         conf.env.LIB_CURL = ['ssh2', 'idn']
193     else:
194         conf.check_cfg(package='libcurl', args='--cflags --libs', atleast_version='7.19.1', uselib_store='CURL', mandatory=True)
195
196     # libicu
197     if conf.check_cfg(package='icu-i18n', args='--cflags --libs', uselib_store='ICU', mandatory=False) is None:
198         if conf.check_cfg(package='icu', args='--cflags --libs', uselib_store='ICU', mandatory=False) is None:
199             conf.check_cxx(fragment="""
200                             #include <unicode/ucsdet.h>
201                             int main(void) {
202                                 UErrorCode status = U_ZERO_ERROR;
203                                 UCharsetDetector* detector = ucsdet_open (&status);
204                                 return 0; }\n
205                             """,
206                        mandatory=True,
207                        msg='Checking for libicu',
208                        okmsg='yes',
209                        libpath=['/usr/local/lib', '/usr/lib', '/usr/lib/x86_64-linux-gnu'],
210                        lib=['icuio', 'icui18n', 'icudata', 'icuuc'],
211                        uselib_store='ICU')
212
213     # libsamplerate
214     conf.check_cfg(package='samplerate', args='--cflags --libs', uselib_store='SAMPLERATE', mandatory=True)
215
216     # glib
217     conf.check_cfg(package='glib-2.0', args='--cflags --libs', uselib_store='GLIB', mandatory=True)
218
219     # libzip
220     conf.check_cfg(package='libzip', args='--cflags --libs', uselib_store='ZIP', mandatory=True)
221     conf.check_cxx(fragment="""
222                             #include <zip.h>
223                             int main() { zip_source_t* foo; }
224                             """,
225                    mandatory=False,
226                    msg="Checking for zip_source_t",
227                    uselib="ZIP",
228                    define_name='DCPOMATIC_HAVE_ZIP_SOURCE_T'
229                    )
230
231     # fontconfig
232     conf.check_cfg(package='fontconfig', args='--cflags --libs', uselib_store='FONTCONFIG', mandatory=True)
233
234     # pangomm
235     conf.check_cfg(package='pangomm-1.4', args='--cflags --libs', uselib_store='PANGOMM', mandatory=True)
236
237     # cairomm
238     conf.check_cfg(package='cairomm-1.0', args='--cflags --libs', uselib_store='CAIROMM', mandatory=True)
239
240     test_cxxflags = ''
241     if have_c11:
242         test_cxxflags = '-std=c++11'
243
244     # See if we have Cairo::ImageSurface::format_stride_for_width; Centos 5 does not
245     conf.check_cxx(fragment="""
246                             #include <cairomm/cairomm.h>
247                             int main(void) {
248                                 Cairo::ImageSurface::format_stride_for_width (Cairo::FORMAT_ARGB32, 1024);\n
249                                 return 0; }\n
250                             """,
251                        mandatory=False,
252                        cxxflags=test_cxxflags,
253                        msg='Checking for format_stride_for_width',
254                        okmsg='yes',
255                        includes=conf.env['INCLUDES_CAIROMM'],
256                        uselib='CAIROMM',
257                        define_name='DCPOMATIC_HAVE_FORMAT_STRIDE_FOR_WIDTH')
258
259     # See if we have Pango::Layout::show_in_cairo_context; Centos 5 does not
260     conf.check_cxx(fragment="""
261                             #include <pangomm.h>
262                             int main(void) {
263                                 Cairo::RefPtr<Cairo::Context> context;
264                                 Glib::RefPtr<Pango::Layout> layout;
265                                 layout->show_in_cairo_context (context);
266                                 return 0; }\n
267                             """,
268                        mandatory=False,
269                        msg='Checking for show_in_cairo_context',
270                        cxxflags=test_cxxflags,
271                        okmsg='yes',
272                        includes=conf.env['INCLUDES_PANGOMM'],
273                        uselib='PANGOMM',
274                        define_name='DCPOMATIC_HAVE_SHOW_IN_CAIRO_CONTEXT')
275
276
277     # libcxml
278     if conf.options.static_cxml:
279         conf.check_cfg(package='libcxml', atleast_version='0.15.5', args='--cflags', uselib_store='CXML', mandatory=True)
280         conf.env.STLIB_CXML = ['cxml']
281     else:
282         conf.check_cfg(package='libcxml', atleast_version='0.15.5', args='--cflags --libs', uselib_store='CXML', mandatory=True)
283
284     # libssh
285     if conf.options.static_ssh:
286         conf.env.STLIB_SSH = ['ssh']
287         if conf.options.workaround_gssapi:
288             conf.env.LIB_SSH = ['gssapi_krb5']
289     else:
290         conf.check_cc(fragment="""
291                                #include <libssh/libssh.h>\n
292                                int main () {\n
293                                ssh_session s = ssh_new ();\n
294                                return 0;\n
295                                }
296                                """,
297                       msg='Checking for library libssh',
298                       mandatory=True,
299                       lib='ssh',
300                       uselib_store='SSH')
301
302     # libdcp
303     if conf.options.static_dcp:
304         conf.check_cfg(package='libdcp-1.0', atleast_version='1.5.1', args='--cflags', uselib_store='DCP', mandatory=True)
305         conf.env.DEFINES_DCP = [f.replace('\\', '') for f in conf.env.DEFINES_DCP]
306         conf.env.STLIB_DCP = ['dcp-1.0', 'asdcp-cth', 'kumu-cth', 'openjp2']
307         conf.env.LIB_DCP = ['glibmm-2.4', 'ssl', 'crypto', 'bz2', 'xslt']
308     else:
309         conf.check_cfg(package='libdcp-1.0', atleast_version='1.5.1', args='--cflags --libs', uselib_store='DCP', mandatory=True)
310         conf.env.DEFINES_DCP = [f.replace('\\', '') for f in conf.env.DEFINES_DCP]
311
312     # libsub
313     if conf.options.static_sub:
314         conf.check_cfg(package='libsub-1.0', atleast_version='1.3.0', args='--cflags', uselib_store='SUB', mandatory=True)
315         conf.env.DEFINES_SUB = [f.replace('\\', '') for f in conf.env.DEFINES_SUB]
316         conf.env.STLIB_SUB = ['sub-1.0']
317     else:
318         conf.check_cfg(package='libsub-1.0', atleast_version='1.3.0', args='--cflags --libs', uselib_store='SUB', mandatory=True)
319         conf.env.DEFINES_SUB = [f.replace('\\', '') for f in conf.env.DEFINES_SUB]
320
321     # libxml++
322     if conf.options.static_xmlpp:
323         conf.env.STLIB_XMLPP = ['xml++-2.6']
324         conf.env.LIB_XMLPP = ['xml2']
325     else:
326         conf.check_cfg(package='libxml++-2.6', args='--cflags --libs', uselib_store='XMLPP', mandatory=True)
327
328     # libxmlsec
329     if conf.options.static_xmlsec:
330         if conf.check_cxx(lib='xmlsec1-openssl', mandatory=False):
331             conf.env.STLIB_XMLSEC = ['xmlsec1-openssl', 'xmlsec1']
332         else:
333             conf.env.STLIB_XMLSEC = ['xmlsec1']
334     else:
335         conf.env.LIB_XMLSEC = ['xmlsec1-openssl', 'xmlsec1']
336
337     # nettle
338     conf.check_cfg(package="nettle", args='--cflags --libs', uselib_store='NETTLE', mandatory=True)
339
340     # libpng
341     conf.check_cfg(package='libpng', args='--cflags --libs', uselib_store='PNG', mandatory=True)
342
343     # FFmpeg
344     if conf.options.static_ffmpeg:
345         names = ['avformat', 'avfilter', 'avcodec', 'avutil', 'swscale', 'postproc', 'swresample']
346         for name in names:
347             static = subprocess.Popen(shlex.split('pkg-config --static --libs lib%s' % name), stdout=subprocess.PIPE).communicate()[0].decode('utf-8')
348             libs = []
349             stlibs = []
350             include = []
351             libpath = []
352             for s in static.split():
353                 if s.startswith('-L'):
354                     libpath.append(s[2:])
355                 elif s.startswith('-I'):
356                     include.append(s[2:])
357                 elif s.startswith('-l'):
358                     if s[2:] not in names:
359                         libs.append(s[2:])
360                     else:
361                         stlibs.append(s[2:])
362
363             conf.env['LIB_%s' % name.upper()] = libs
364             conf.env['STLIB_%s' % name.upper()] = stlibs
365             conf.env['INCLUDES_%s' % name.upper()] = include
366             conf.env['LIBPATH_%s' % name.upper()] = libpath
367     else:
368         conf.check_cfg(package='libavformat', args='--cflags --libs', uselib_store='AVFORMAT', mandatory=True)
369         conf.check_cfg(package='libavfilter', args='--cflags --libs', uselib_store='AVFILTER', mandatory=True)
370         conf.check_cfg(package='libavcodec', args='--cflags --libs', uselib_store='AVCODEC', mandatory=True)
371         conf.check_cfg(package='libavutil', args='--cflags --libs', uselib_store='AVUTIL', mandatory=True)
372         conf.check_cfg(package='libswscale', args='--cflags --libs', uselib_store='SWSCALE', mandatory=True)
373         conf.check_cfg(package='libpostproc', args='--cflags --libs', uselib_store='POSTPROC', mandatory=True)
374         conf.check_cfg(package='libswresample', args='--cflags --libs', uselib_store='SWRESAMPLE', mandatory=True)
375
376     # Check to see if we have our version of FFmpeg that allows us to get at EBUR128 results
377     conf.check_cxx(fragment="""
378                             extern "C" {\n
379                             #include <libavfilter/f_ebur128.h>\n
380                             }\n
381                             int main () { av_ebur128_get_true_peaks (0); }\n
382                             """,
383                    msg='Checking for EBUR128-patched FFmpeg',
384                    uselib='AVCODEC AVFILTER',
385                    define_name='DCPOMATIC_HAVE_EBUR128_PATCHED_FFMPEG',
386                    mandatory=False)
387
388     # Check to see if we have our AVSubtitleRect has a pict member
389     # Older versions (e.g. that shipped with Ubuntu 16.04) do
390     conf.check_cxx(fragment="""
391                             extern "C" {\n
392                             #include <libavcodec/avcodec.h>\n
393                             }\n
394                             int main () { AVSubtitleRect r; r.pict; }\n
395                             """,
396                    msg='Checking for AVSubtitleRect::pict',
397                    cxxflags='-Wno-unused-result -Wno-unused-value -Wdeprecated-declarations -Werror',
398                    uselib='AVCODEC',
399                    define_name='DCPOMATIC_HAVE_AVSUBTITLERECT_PICT',
400                    mandatory=False)
401
402     # Check to see if we have our AVComponentDescriptor has a depth_minus1 member
403     # Older versions (e.g. that shipped with Ubuntu 16.04) do
404     conf.check_cxx(fragment="""
405                             extern "C" {\n
406                             #include <libavutil/pixdesc.h>\n
407                             }\n
408                             int main () { AVComponentDescriptor d; d.depth_minus1; }\n
409                             """,
410                    msg='Checking for AVComponentDescriptor::depth_minus1',
411                    cxxflags='-Wno-unused-result -Wno-unused-value -Wdeprecated-declarations -Werror',
412                    uselib='AVUTIL',
413                    define_name='DCPOMATIC_HAVE_AVCOMPONENTDESCRIPTOR_DEPTH_MINUS1',
414                    mandatory=False)
415
416     # Hack: the previous two check_cxx calls end up copying their (necessary) cxxflags
417     # to these variables.  We don't want to use these for the actual build, so clean them out.
418     conf.env['CXXFLAGS_AVCODEC'] = []
419     conf.env['CXXFLAGS_AVUTIL'] = []
420
421     # Boost
422     if conf.options.static_boost:
423         conf.env.STLIB_BOOST_THREAD = ['boost_thread']
424         conf.env.STLIB_BOOST_FILESYSTEM = ['boost_filesystem%s' % boost_lib_suffix]
425         conf.env.STLIB_BOOST_DATETIME = ['boost_date_time%s' % boost_lib_suffix, 'boost_system%s' % boost_lib_suffix]
426         conf.env.STLIB_BOOST_SIGNALS2 = ['boost_signals2']
427         conf.env.STLIB_BOOST_SYSTEM = ['boost_system']
428         conf.env.STLIB_BOOST_REGEX = ['boost_regex']
429     else:
430         conf.check_cxx(fragment="""
431                             #include <boost/version.hpp>\n
432                             #if BOOST_VERSION < 104500\n
433                             #error boost too old\n
434                             #endif\n
435                             int main(void) { return 0; }\n
436                             """,
437                        mandatory=True,
438                        msg='Checking for boost library >= 1.45',
439                        okmsg='yes',
440                        errmsg='too old\nPlease install boost version 1.45 or higher.')
441
442         conf.check_cxx(fragment="""
443                             #include <boost/thread.hpp>\n
444                             int main() { boost::thread t (); }\n
445                             """,
446                        msg='Checking for boost threading library',
447                        libpath='/usr/local/lib',
448                        lib=[boost_thread, 'boost_system%s' % boost_lib_suffix],
449                        uselib_store='BOOST_THREAD')
450
451         conf.check_cxx(fragment="""
452                             #include <boost/filesystem.hpp>\n
453                             int main() { boost::filesystem::copy_file ("a", "b"); }\n
454                             """,
455                        msg='Checking for boost filesystem library',
456                        libpath='/usr/local/lib',
457                        lib=['boost_filesystem%s' % boost_lib_suffix, 'boost_system%s' % boost_lib_suffix],
458                        uselib_store='BOOST_FILESYSTEM')
459
460         conf.check_cxx(fragment="""
461                             #include <boost/date_time.hpp>\n
462                             int main() { boost::gregorian::day_clock::local_day(); }\n
463                             """,
464                        msg='Checking for boost datetime library',
465                        libpath='/usr/local/lib',
466                        lib=['boost_date_time%s' % boost_lib_suffix, 'boost_system%s' % boost_lib_suffix],
467                        uselib_store='BOOST_DATETIME')
468
469         conf.check_cxx(fragment="""
470                             #include <boost/signals2.hpp>\n
471                             int main() { boost::signals2::signal<void (int)> x; }\n
472                             """,
473                        msg='Checking for boost signals2 library',
474                        uselib_store='BOOST_SIGNALS2')
475
476         conf.check_cxx(fragment="""
477                             #include <boost/regex.hpp>\n
478                             int main() { boost::regex re ("foo"); }\n
479                             """,
480                        msg='Checking for boost regex library',
481                        lib=['boost_regex%s' % boost_lib_suffix],
482                        uselib_store='BOOST_REGEX')
483
484     # libxml++ requires glibmm and versions of glibmm 2.45.31 and later
485     # must be built with -std=c++11 as they use c++11
486     # features and c++11 is not (yet) the default in gcc.
487     glibmm_version = conf.cmd_and_log(['pkg-config', '--modversion', 'glibmm-2.4'], output=Context.STDOUT, quiet=Context.BOTH)
488     s = glibmm_version.split('.')
489     v = (int(s[0]) << 16) | (int(s[1]) << 8) | int(s[2])
490     if v >= 0x022D1F:
491         conf.env.append_value('CXXFLAGS', '-std=c++11')
492
493     # Other stuff
494
495     conf.find_program('msgfmt', var='MSGFMT')
496     conf.check(header_name='valgrind/memcheck.h', mandatory=False)
497
498     datadir = conf.env.DATADIR
499     if not datadir:
500         datadir = os.path.join(conf.env.PREFIX, 'share')
501
502     conf.define('LOCALEDIR', os.path.join(datadir, 'locale'))
503     conf.define('DATADIR', datadir)
504
505     conf.recurse('src')
506     if not conf.env.DISABLE_TESTS:
507         conf.recurse('test')
508
509     Logs.pprint('YELLOW', '')
510     if conf.env.TARGET_WINDOWS:
511         Logs.pprint('YELLOW', '\t' + 'Target'.ljust(25) + ': Windows')
512     elif conf.env.TARGET_LINUX:
513         Logs.pprint('YELLOW', '\t' + 'Target'.ljust(25) + ': Linux')
514     elif conf.env.TARGET_OSX:
515         Logs.pprint('YELLOW', '\t' + 'Target'.ljust(25) + ': OS X')
516
517     def report(name, variable):
518         linkage = ''
519         if variable:
520             linkage = 'static'
521         else:
522             linkage = 'dynamic'
523         Logs.pprint('YELLOW', '\t%s: %s' % (name.ljust(25), linkage))
524
525     report('DCP-o-matic libraries', conf.options.static_dcpomatic)
526     report('Boost', conf.options.static_boost)
527     report('wxWidgets', conf.options.static_wxwidgets)
528     report('FFmpeg', conf.options.static_ffmpeg)
529     report('libxml++', conf.options.static_xmlpp)
530     report('xmlsec', conf.options.static_xmlsec)
531     report('libssh', conf.options.static_ssh)
532     report('libcxml', conf.options.static_cxml)
533     report('libdcp', conf.options.static_dcp)
534     report('libcurl', conf.options.static_curl)
535
536     Logs.pprint('YELLOW', '')
537
538 def download_supporters(can_fail):
539     last_date = subprocess.Popen(shlex.split('git log -1 --format=%%ai %s' % last_version), stdout=subprocess.PIPE).communicate()[0]
540     r = os.system('curl -s -f https://dcpomatic.com/supporters.cc?%s > src/wx/supporters.cc' % urlencode({"until": last_date.strip()}))
541     if (r >> 8) == 0:
542         r = os.system('curl -s -f https://dcpomatic.com/subscribers.cc?%s > src/wx/subscribers.cc' % urlencode({"until": last_date.strip()}))
543     if (r >> 8) != 0 and can_fail:
544         raise Exception("Could not download supporters lists")
545
546 def build(bld):
547     create_version_cc(VERSION, bld.env.CXXFLAGS)
548     download_supporters(not bld.env.DEBUG)
549
550     bld.recurse('src')
551     bld.recurse('graphics')
552
553     if not bld.env.DISABLE_TESTS:
554         bld.recurse('test')
555     if bld.env.TARGET_WINDOWS:
556         bld.recurse('platform/windows')
557     if bld.env.TARGET_LINUX:
558         bld.recurse('platform/linux')
559     if bld.env.TARGET_OSX:
560         bld.recurse('platform/osx')
561
562     if not bld.env.TARGET_WINDOWS:
563         bld.install_files('${PREFIX}/share/dcpomatic2', 'fonts/LiberationSans-Regular.ttf')
564         bld.install_files('${PREFIX}/share/dcpomatic2', 'fonts/LiberationSans-Italic.ttf')
565         bld.install_files('${PREFIX}/share/dcpomatic2', 'fonts/LiberationSans-Bold.ttf')
566
567     bld.add_post_fun(post)
568
569 def git_revision():
570     if not os.path.exists('.git'):
571         return None
572
573     cmd = "LANG= git log --abbrev HEAD^..HEAD ."
574     output = subprocess.Popen(cmd, shell=True, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
575     if len(output) == 0:
576         return None
577     o = output[0].decode('utf-8')
578     return o.replace("commit ", "")[0:10]
579
580 def dist(ctx):
581     r = git_revision()
582     if r is not None:
583         f = open('.git_revision', 'w')
584         print >>f,r
585     f.close()
586
587     ctx.excl = """
588                TODO core *~ src/wx/*~ src/lib/*~ builds/*~ doc/manual/*~ src/tools/*~ *.pyc .waf* build .git
589                deps alignment hacks sync *.tar.bz2 *.exe .lock* *build-windows doc/manual/pdf doc/manual/html
590                GRSYMS GRTAGS GSYMS GTAGS compile_commands.json
591                """
592
593 def create_version_cc(version, cxx_flags):
594     commit = git_revision()
595     if commit is None and os.path.exists('.git_revision'):
596         f = open('.git_revision', 'r')
597         commit = f.readline().strip()
598
599     if commit is None:
600         commit = 'release'
601
602     try:
603         text =  '#include "version.h"\n'
604         text += 'char const * dcpomatic_git_commit = \"%s\";\n' % commit
605         text += 'char const * dcpomatic_version = \"%s\";\n' % version
606
607         t = ''
608         for f in cxx_flags:
609             f = f.replace('"', '\\"')
610             t += f + ' '
611         text += 'char const * dcpomatic_cxx_flags = \"%s\";\n' % t[:-1]
612
613         print('Writing version information to src/lib/version.cc')
614         o = open('src/lib/version.cc', 'w')
615         o.write(text)
616         o.close()
617     except IOError:
618         print('Could not open src/lib/version.cc for writing\n')
619         sys.exit(-1)
620
621 def post(ctx):
622     if ctx.cmd == 'install':
623         ctx.exec_command('/sbin/ldconfig')
624
625 def pot(bld):
626     bld.recurse('src')
627
628 def pot_merge(bld):
629     bld.recurse('src')
630
631 def tags(bld):
632     os.system('etags src/lib/*.cc src/lib/*.h src/wx/*.cc src/wx/*.h src/tools/*.cc')
633
634 def cppcheck(bld):
635     os.system('cppcheck --enable=all --quiet .')